package examination3;

/**
 * Add Javadoc comments to each of the methods
 * (f0 to f6) in this class.
 * 
 * <p>
 * This code is related to the SurfingSafari program
 * and the code in section 1.6 of our textbook.
 * <p>
 * 
 * @author Your Name
 * @version 30 January 2015
 */
public class Matrix {

  public static final int DIM = 3;

  public Matrix() {
    double[] vector = f2(DIM);

    f0(vector);
    System.out.println();

    double[][] matrix = f3(DIM);

    f1(matrix);
    System.out.println();

    f4(matrix);

    f1(matrix);
    System.out.println();

    int n = 1;
    for (int i = 0; i < n; i++) {
      vector = f6(vector, matrix);
    } // for

    f0(vector);
    System.out.println();

    f5(matrix);

    f1(matrix);
    System.out.println();

    int hops = 12;
    int page = 0;
    for (int i = 0; i < hops; i++) {
      System.out.println("Visiting page #" + page);
      double r = Math.random();
      int j = 0;
      while (r > matrix[page][j]) {
        j++;
      } // while
      page = j;
    } // for

  } // Matrix()

  public final void f0(double[] v) {
    for (double x : v) {
      System.out.printf("%6.2f ", x);
    } // for
    System.out.println();
  } // f0( double [] )

  public final void f1(double[][] m) {
    for (double[] row : m) {
      f0(row);
    } // for
  } // f1( double [][] )

  public final double[] f2(int n) {
    double[] vector = new double[DIM];
    vector[0] = 1.0;
    for (int i = 1; i < DIM; i++) {
      vector[i] = 0.0;
    } // for
    return vector;
  } // f2( int )

  public final double[][] f3(int n) {
    double[][] matrix = new double[DIM][DIM];
    for (int i = 0; i < DIM; i++) {
      for (int j = 0; j < DIM; j++) {
        matrix[i][j] = Math.random();
      } // for
    } // for
    return matrix;
  } // f3( int )

  public final void f4(double[][] matrix) {
    for (int i = 0; i < DIM; i++) {

      double sum = 0.0;
      for (int j = 0; j < DIM; j++) {
        sum += matrix[i][j];
      } // for

      for (int j = 0; j < DIM; j++) {
        matrix[i][j] /= sum;
      } // for
    } // for
  } // f4( double [][] )

  public final void f5(double[][] matrix) {
    for (int i = 0; i < DIM; i++) {
      for (int j = 1; j < DIM; j++) {
        matrix[i][j] = matrix[i][j] + matrix[i][j - 1];
      } // for
    } // for
  } // f5( double [][] )

  public final double[] f6(double[] vector,
          double[][] matrix) {
    double[] product = new double[DIM];

    for (int i = 0; i < DIM; i++) {
      double sumOfProducts = 0.0;
      for (int j = 0; j < DIM; j++) {
        sumOfProducts += vector[j] * matrix[j][i];
      } // for
      product[i] = sumOfProducts;
    } // for
    return product;
  } // f6( double [], double [][] )

} // Matrix
