package examination3;

/**
 * Add Javadoc comments to each of the methods
 * (f0 to f8) in this class.
 * 
 * <p>
 * This code is related to our study of
 * sorting algorithms.
 * </p>
 * 
 * @author Your Name
 * @version 30 January 2015
 */
public class Sort {

  public static final int SIZE = 12;

  public Sort() {
    double[] data = f0(SIZE);
    f1(data);
    f8(data);
    f1(data);

    System.out.println();

    data = f0(SIZE);
    f1(data);
    f7(data);
    f1(data);
  } // Sort()
  
  public final double[] f0(int n) {
    double[] result = new double[n];
    for (int i = 0; i < result.length; i++) {
      result[i] = Math.random();
    } // for
    return result;
  } // f0( int )

  public final void f1(double[] data) {
    for (double x : data) {
      System.out.printf("%6.2f ", x);
    } // for
    System.out.println();
  } // f1( double [] )

  public final void f2(double[] data, int prefixLength) {
    System.out.print("[");
    for (int i = 0; i < prefixLength; i++) {
      System.out.printf("%6.2f ", data[i]);
    } // for
    System.out.print("][");
    for (int i = prefixLength; i < data.length; i++) {
      System.out.printf("%6.2f ", data[i]);
    } // for
    System.out.println("]");
  } // f2( double [] )

  public final void f3(double[] data, int i, int j) {
    double temp = data[i];
    data[i] = data[j];
    data[j] = temp;
  } // f3( double [], int, int )

  public final int f4(double[] data, int start) {
    int bestGuessSoFar = start;
    for (int i = start + 1; i < data.length; i++) {
      if (data[i] < data[bestGuessSoFar]) {
        bestGuessSoFar = i;
      } // if
    } // for
    return bestGuessSoFar;
  } // f4( double [], int )

  public final void f5(double[] data, int i, int j) {
    double temp = data[i];
    for (int k = i; k > j; k--) {
      data[k] = data[k - 1];
    } // for
    data[j] = temp;
  } // f5( double [], int, int )

  public final int f6(double[] data, int i) {
    int j = i;
    while (j > 0 && data[j - 1] > data[i]) {
      j--;
    } // while
    return j;
  } // f6( double [], int )

  public final void f7(double[] data) {
    for (int i = 0; i < data.length; i++) {
      f2(data, i);
      int j = f4(data, i);
      f3(data, i, j);
    } // for
  } // f7( double [] )

  public final void f8(double[] data) {
    for (int i = 0; i < data.length; i++) {
      f2(data, i);
      int j = f6(data, i);
	    //System.out.printf( 
      //  "move data[%2d] to data[%2d] (%6.2f -> %6.2f)\n", 
      //  i, j, data[i], data[j] );
      f5(data, i, j);
    } // for
  } // f8( double [] )
  
} // Sort
